uulib-0.9.24: Haskell Utrecht Tools Library

Safe Haskell | Safe-Inferred
Language | Haskell98

UU.Util.PermTree

# Documentation

data Perms p a Source #

Constructors

Choice (Maybe a) [Branch p a] |

#### Instances

Instances details

Functor (Perms p) Source # |
Instance details Defined in UU.Util.PermTree Methods fmap :: (a -> b) -> Perms p a -> Perms p b Source # (<$) :: a -> Perms p b -> Perms p a Source #

data Branch p a Source #

Constructors

forall x. Br (p x) (Perms p (x -> a)) |

#### Instances

Instances details

Functor (Branch p) Source # |
Instance details Defined in UU.Util.PermTree Methods fmap :: (a -> b) -> Branch p a -> Branch p b Source # (<$) :: a -> Branch p b -> Branch p a Source #

add :: Maybe a -> p a -> Perms p (a -> b) -> Perms p b Source #

empty :: a -> Perms p a Source #

(<$$>) :: (a -> b) -> p a -> Perms p b Source #

(<$?>) :: (a -> b) -> (a, p a) -> Perms p b Source #

(<||>) :: Perms p (a -> b) -> p a -> Perms p b Source #

(<|?>) :: Perms p (a -> b) -> (a, p a) -> Perms p b Source #